/************************************************************************/
/* Licensed Materials – Property of  HCL                                */
/* (c) Copyright HCL Technologies Ltd. 2016, 2017 All rights reserved.  */
/* Trademark of HCL Technologies Limited                                */
/************************************************************************/

const fs = require('fs-extra');
const async = require('async');
var workManager = require('../modules/workManager');

module.exports = function () {
	var Importer = {};

	Importer.doImport = function (expImpPath) {
		var config = require('../modules/config');
		var Users = require('../models/user');

		var usersFile = expImpPath + '/users.json';

		async.waterfall([
			// read users from file
			function (callback) {
				workManager.workStarted();
                winston.info('Importing users');
				fs.readJson(usersFile, { spaces: 4 }, function (err, users) {
					callback(err, users);
				});
			},
			// remove records currently present in db
			function (users, callback) {
				Users.find({}, function (err, usersDBIds) {
					usersDBIds = Array.from(usersDBIds, function(x){ return x._id; });
					for(var i = 0; i<usersDBIds.length; i++){
						for(var j = 0; j<users.length;j++){
							if(usersDBIds[i]==users[j]._id){
								users.splice(j,1);
							}
						}
					}
					callback(err, users);
				});
			},
			// insert the users read from file
			function (users, callback) {
				// now insert
				Users.insertMany(users, function (err) {
					callback(err);
				});
			}
		],
			function (err, result) {
				// all done
                if (err) {
					winston.info('Import Users failed - Error - ', err);
				}

				if (Users != null) {
					Users.closeConnection();
				}

				workManager.workEnded();
			});

	};

	return Importer;
};